      SUBROUTINE DAS2DX(IA,NIA,
     &                  IP,NIP,
     &                  NGX,NGY,
     &                  NPX,NPY,IPX,IPY)
C
C     This subroutine prepares data to perform the 2D 9
C     matrix vector product. 
C
C     ******************************************************************
C
C        IA(2) : To store gridpoints data, resembling the size of  A  on 
C                the finest grid level
C                IA(1) : number of gridpoints in X-direction
C                IA(2) : number of gridpoints in X-direction
C
C        IP(5) : To store parallel computing data. P stands for parallel
C                processor.
C                IP(1) : ICOMM
C                IP(2) : Number of distributed processor. For one proce-
C                        ssor, IP(2) = IPX = 0
C                IP(3) : Number of distributed processor. For one proce-
C                        ssor, IP(2) = IPY = 0
C                IP(4) : Number of processor NPX
C                IP(5) : Number of processor NPY
C
C     ******************************************************************

      IMPLICIT       NONE
C      
      INTEGER        NIA,NIP,NGX,NGY,ngz,IPX,IPY,NPX,NPY  
      INTEGER        IA(NIA),IP(NIP) 
      INTEGER        IERR,ICOMM 

C
      IERR = 0
      ICOMM = 0
C
C     Prepare IA. IA points how the matrix A is processed in parallel
C 
      IF (NIA .LT. 2) IERR = 1
C      
C      CALL IMAX(IERR,1,ICOMM)
C      
      IF (IERR .NE. 0) THEN
         RETURN
      ENDIF
C      
      IA(1) = NGX
      IA(2) = NGY
C
C     Prepare the data for parallel execution. The data is stored in IP
C
      IF (NIP .LT. 5) IERR = 10
C      
      CALL IMAX(IERR,1,ICOMM)      
      IF (IERR .NE. 0) THEN
         RETURN
      ENDIF
C
      IP(1) = ICOMM
      IP(2) = IPX
      IP(3) = IPY
      IP(4) = NPX
      IP(5) = NPY
C      
      RETURN
      END
