      SUBROUTINE ERMSG(IERR)

C     This subroutine is used as an error directive in HSOLV. The  error
C     massage is controlled by a parameter IERR. As long as IERR = 0, no
C     error is detected and the execution continues.

      INTEGER  IERR 
      
      IF (IERR .EQ. 0) THEN
         WRITE(6,*) "... IERR = 0.  No error is found"
      ELSEIF (IERR .EQ. 1) THEN
         WRITE(6,*) ""
      ELSEIF (IERR .EQ. 20) THEN
         WRITE(6,*) "    ERROR TYPE 20 ......."
         WRITE(6,*) "    Unable to initialize  multigrid."
         WRITE(6,*) "    The smoother is not yet defined."
         WRITE(6,*) "    Refer to 2DMG.INPUT file and set"
         WRITE(6,*) "    the smoother with ISWP."
      ELSEIF (IERR .EQ. 21) THEN
         WRITE(6,*) "    ERROR TYPE 21 ......."
         WRITE(6,*) "    Unable to initialize multigrid."
         WRITE(6,*) "    The number of MG level is not set."
         WRITE(6,*) "    Refer to 2DMG.INPUT file and set"
         WRITE(6,*) "    the MG level with M."
      ELSEIF (IERR .EQ. 22) THEN
         WRITE(6,*) "    ERROR TYPE 22 ......."
         WRITE(6,*) "    Unable to initialize multigrid."
         WRITE(6,*) "    The number of MG iter is not set properly."
         WRITE(6,*) "    Refer to 2DMG.INPUT file and set"
         WRITE(6,*) "    the number of MG iteration with NIT."
      ELSEIF (IERR .EQ. 23) THEN
         WRITE(6,*) "    ERROR TYPE 23 ......."
         WRITE(6,*) "    Unable to initialize multigrid."
         WRITE(6,*) "    NR1 and NR2 iteration are not set properly."
         WRITE(6,*) "    Refer to 2DMG.INPUT file and set"
         WRITE(6,*) "    NR1 and NR2."
      ELSEIF (IERR .EQ. 24) THEN
         WRITE(6,*) "    ERROR TYPE 24 ......."
         WRITE(6,*) "    Unable to initialize multigrid."
         WRITE(6,*) "    Type of MG cycle is not yet defined."
         WRITE(6,*) "    Refer to 2DMG.INPUT file and set"
         WRITE(6,*) "    the MG cycle using ICYC."
      ELSEIF (IERR .EQ. 25) THEN
         WRITE(6,*) "    ERROR TYPE 25 ......."
         WRITE(6,*) "    Unable to initialize multigrid."
         WRITE(6,*) "    Number of AC cycle is not yet defined."
         WRITE(6,*) "    Refer to 2DMG.INPUT file and set"
         WRITE(6,*) "    the MG cycle using IAC."
      ENDIF
      
      RETURN
      END
