      subroutine ext2d(w0,nx0,ny0, 
     &                 w1,nx1,ny1,
     &                 witp,
     &                 ix0,iy0,
     &                 neigx,neigy,
     &                 work)
c
c       w1 is the extension of w0
c       w1 <- exten(w0)
c
      implicit    none
      
      integer     ix,iy,ix0,iy0,ix1,iy1,ix2,iy2,ix3,iy3,ixf,iyf 
      integer     nx0,ny0,nx1,ny1 
      integer     neigx(2),neigy(2) 
      
      complex*16  w0(nx0,ny0),w1(nx1,ny1) 
      complex*16  work(0:nx1+1,0:ny1+1) 
      complex*16  witp(nx1,ny1,4) 

      if (nx1.lt.1 .or. ny1.lt.1) return
c
      ix1 = mod(ix0,2)+1
      iy1 = iy0
      ix2 = ix0
      iy2 = mod(iy0,2)+1
      ix3 = mod(ix0,2)+1
      iy3 = mod(iy0,2)+1
c
      do iy = 0,ny1+1
         do ix = 0,nx1+1
            work(ix,iy) = (0.d0,0.d0)
         enddo
      enddo      
      
      do iy = 1, ny0
         iyf = iy0 + iy*2 -2
         do ix = 1, nx0
            ixf = ix0 + ix*2 -2
            work(ixf,iyf) = w0(ix,iy)
         enddo
      enddo
c
c      compute on grid points 1
c
      do iy = iy1, ny1, 2
         do ix = ix1, nx1, 2
            work(ix,iy) = witp(ix,iy,1)*work(ix-1,iy)
     &                  + witp(ix,iy,2)*work(ix+1,iy)
         enddo
      enddo
c
c      compute on grid points 2
c
      do iy = iy2, ny1, 2
         do ix = ix2, nx1, 2
            work(ix,iy) = witp(ix,iy,1)*work(ix,iy-1)
     &                  + witp(ix,iy,2)*work(ix,iy+1)
         enddo
      enddo
c
c      compute on grid points 3
c
      do iy = iy3, ny1, 2
         do ix = ix3, nx1, 2
            work(ix,iy) = witp(ix,iy,1)*work(ix-1,iy-1)
     &                  + witp(ix,iy,2)*work(ix+1,iy-1)
     &                  + witp(ix,iy,3)*work(ix-1,iy+1)
     &                  + witp(ix,iy,4)*work(ix+1,iy+1)
         enddo
      enddo
c
      do iy = 1, ny1
         do ix = 1, nx1
            w1(ix,iy) = work(ix,iy)
         enddo
      enddo
      
      return
      end
