      subroutine makeblo1(ngx,ngy,xl,yl,xs,ys,bs)
            
      implicit none
c      
      integer       ix,iy,ngx,ngy,ngxt,ngyt,ngxs,ngys   
      real*8        xl,yl,xs,ys,hx,hy
      complex*16    bs(ngx,ngy) 
c
      ngxt = ngx
      ngyt = ngy
c      
      hx = xl/dble(float(ngx+1))
      hy = yl/dble(float(ngy+1))
c
      ngxs = int(xs/hx)
      ngys = int(ys/hy)
c
      do iy = 1,ngyt
        do ix = 1,ngxt
	  if (ix .eq. ngxs .and. iy .eq. ngys) then
	    bs(ix,iy) = 1.d0/(hx*hy)
	  else
	    bs(ix,iy) = 0.d0
	  endif
	enddo
      enddo
c
      return
      end
c
c *******************************************************
c
      subroutine makeblo2(ngx,ngy,xl,yl,xs,ys,bs)
            
      implicit none
c      
      integer       ix,iy,ngx,ngy,ngxt,ngyt,ngxs,ngys   
      real*8        xl,yl,xs,ys,hx,hy
      complex*16    bs(0:ngx+1,0:ngy+1) 
c
      ngxt = ngx
      ngyt = ngy
c      
      hx = xl/dble(float(ngx+1))
      hy = yl/dble(float(ngy+1))
c
      ngxs = int(xs/hx)
      ngys = int(ys/hy)
c
      write(*,*) ngxs,ngys
c
      do iy = 0,ngyt+1
        do ix = 0,ngxt+1
	  if (ix .eq. ngxs .and. iy .eq. ngys) then
	    bs(ix,iy) = 1.d0/(hx*hy)
	  else
	    bs(ix,iy) = 0.d0
	  endif
	enddo
      enddo
c
      return
      end
c
c     **************************************************      
c
c
      subroutine makebhodl(ngx,ngy,ngxd,ngyd,xl,yl,xs,ys,bs) 
c
c     This subroutine returns the right-hand side vector b of the
c     system
c
c            A*x = b.
c
c     In present version, the right-hand side vector represents
c     problems with one source located at a certain position in
c     the physical domain. This position is supplied by the user
c     as part of the input2d.dat file, in terms of coordinates
c     (xs,ys).
c     The actual position on the grid is determined by the nearest
c     gridpoint to that position.
c
c
      implicit none
c
      integer     ix,iy,irhs 
      integer     ngx,ngy,ngxd,ngyd,ngxt,ngyt,ngxs,ngys 
      complex*16  bs(ngx+2*ngxd,ngy+2*ngyd) 
      real*8      xl,yl,hx,hy,xs,ys 
c
      ngxt = 2*ngxd+ngx
      ngyt = 2*ngyd+ngy
c
c     Compute the gridsize
c
      hx = xl/dble(float(ngx+1))
      hy = yl/dble(float(ngy+1)) 
c
c     Compute the gridpoint corresponding to the source location
c
      ngxs = int(xs/hx)
      ngys = int(ys/hy)
c
      do iy = 1,ngyt
        do ix = 1,ngxt
          if	 (ix .eq. ngxd+ngxs-1 .and. iy .eq. ngyd+ngys-1) then
            bs(ix,iy) = 1.d0/1.44d2*(1.d0,0.d0)/(hx*hy)
          elseif (ix .eq. ngxd+ngxs   .and. iy .eq. ngyd+ngys-1) then
            bs(ix,iy) = 5.d0/7.2d1*(1.d0,0.d0)/(hx*hy)
          elseif (ix .eq. ngxd+ngxs+1 .and. iy .eq. ngyd+ngys-1) then
            bs(ix,iy) = 1.d0/1.44d2*(1.d0,0.d0)/(hx*hy)
          elseif (ix .eq. ngxd+ngxs-1 .and. iy .eq. ngyd+ngys  ) then 
            bs(ix,iy) = 5.d0/7.2d1*(1.d0,0.d0)/(hx*hy)  
          elseif (ix .eq. ngxd+ngxs   .and. iy .eq. ngyd+ngys  ) then 
            bs(ix,iy) = 2.5d1/3.6d1*(1.d0,0.d0)/(hx*hy)
          elseif (ix .eq. ngxd+ngxs+1 .and. iy .eq. ngyd+ngys  ) then 
            bs(ix,iy) = 5.d0/7.2d1*(1.d0,0.d0)/(hx*hy)
          elseif (ix .eq. ngxd+ngxs-1 .and. iy .eq. ngyd+ngys+1) then
            bs(ix,iy) = 1.d0/1.44d2*(1.d0,0.d0)/(hx*hy)
          elseif (ix .eq. ngxd+ngxs   .and. iy .eq. ngyd+ngys+1) then
            bs(ix,iy) = 5.d0/7.2d1*(1.d0,0.d0)/(hx*hy)
          elseif (ix .eq. ngxd+ngxs+1 .and. iy .eq. ngyd+ngys+1) then
            bs(ix,iy) = 1.d0/1.44d2*(1.d0,0.d0)/(hx*hy)
          else
            bs(ix,iy) = (0.d0,0.d0)
          endif
        enddo
      enddo
c
      return
      end


