      subroutine mat2d9p(ngx,ngy,x,y,a,work)

c     The subroutine returns the Y = A*X, where A is a matrix related to
c     a nine-point Finite Difference stencil.
     
      implicit    none
      
      integer     ix,iy,ngx,ngy 
      complex*16  a(ngx,ngy,-1:1,-1:1) 
      complex*16  work(0:ngx+1,0:ngy+1) 
      complex*16  x(ngx,ngy),y(ngx,ngy)  
c
      do iy = 0,ngy+1
         do ix = 0,ngx+1
            work(ix,iy) = (0.d0,0.d0)
         enddo
      enddo
      
      do iy = 1,ngy
         do ix = 1,ngx
            work(ix,iy) = x(ix,iy)
         enddo
      enddo
C 
      do iy = 1,ngy
         do ix = 1,ngx
            y(ix,iy) = a(ix,iy,-1,-1)*work(ix-1,iy-1)
     &               + a(ix,iy, 0,-1)*work(ix  ,iy-1)
     &               + a(ix,iy, 1,-1)*work(ix+1,iy-1)
     &               + a(ix,iy,-1, 0)*work(ix-1,iy)
     &               + a(ix,iy, 0, 0)*work(ix  ,iy)
     &               + a(ix,iy, 1, 0)*work(ix+1,iy)
     &               + a(ix,iy,-1, 1)*work(ix-1,iy+1)
     &               + a(ix,iy, 0, 1)*work(ix  ,iy+1)
     &               + a(ix,iy, 1, 1)*work(ix+1,iy+1)
         enddo
      enddo
      
      return
      end
