      subroutine mg2d(ngx,ngy,xl,yl,p,q,ap,
     &                m,nx,ny,indx, 
     &                icyc, 
     &                iswp,nr1,nr2,niter, 
     &                md,iac,mr,imin,mj,
     &                acor,dinv,  
     &                wrst,witp,
     &                r,f,work,
     &                omega,
     &                ix0,iy0,
     &                neigx,neigy,
     &                neigxc,neigyc, 
     &                ixg,iyg,ngall0,ngall1)

      implicit    none 
      
      integer     m,mc,ngx,ngy,nxy,nr1,nr2,iswp,icyc,mr,imin,md,iac,mj  
      integer     nxyf,nxyc 
      integer     ngall0,ngall1,nr 
      integer     nx(m),ny(m),indx(m) 
      integer     ix,iy,ix0(m),iy0(m),ixg(m),iyg(m) 
      integer     neigx(2,m),neigy(2,m),neigxc(2,m),neigyc(2,m) 
      integer     ipt4,ipt4f,ipt9c  
      integer     it,niter 
      
      complex*16  acor(*),dinv(*),ap(*) 
      complex*16  p(ngx,ngy),q(ngx,ngy),work(*) 
      complex*16  r(ngx*ngy),w(ngall0),f(ngall0) 
      complex*16  wrst(9*ngall0),witp(4*ngall1) 
      real*8      xl,yl 
      complex*16  omega 
c
c     Smoothing on the finest grid.
c
c      write(*,*) m
      nxy  = ngx*ngy
      ipt4 = (indx(m)-1)*4 + 1
c
c     If only having one level (no coarser grid level)
      
c      write(*,*) iswp
      if (m .eq. 1) then
         nr = max(nr1,nr2)
         if (iswp .eq. 0) then
            call sor2c4f(ap,dinv(indx(m)),q,p,
     &                   ngx,ngy,xl,yl,
     &                   nr,omega, 
     &                   ix0(m),iy0(m),work)
         elseif (iswp .eq. 1) then
            call sor5ptf(ap,dinv(indx(m)),q,p,
     &                   ngx,ngy,xl,yl,
     &                   nr,omega, 
     &                   ix0(m),iy0(m),work)
         elseif (iswp .eq. 2) then
            call pjacf(ap,dinv(indx(m)),q,p,
     &                 ngx,ngy,xl,yl,
     &                 nr,omega, 
     &                 ix0(m),iy0(m),work)
         elseif (iswp .eq. 3) then
            call pjac2f(ap,dinv(indx(m)),q,p,
     &                  ngx,ngy,xl,yl,
     &                  nr,omega, 
     &                  ix0(m),iy0(m),work)
         elseif (iswp .eq. 4) then
            call pjacf(ap,dinv(indx(m)),q,p,
     &                 ngx,ngy,xl,yl,
     &                 nr,omega, 
     &                 ix0(m),iy0(m),work)
         endif
         return
      endif
c
c     The following lines are only used if at least two gridlevels are
c     available. It means m > 1 (see input "m" in the file 2DMG.INPUT)
c
      do it = 1,niter
         if (nr1 .gt. 0) then
           if (iswp .eq. 0) then
              call sor2c4f(ap,dinv(indx(m)),q,p,
     &                     ngx,ngy,xl,yl,
     &                     nr1,omega, 
     &                     ix0(m),iy0(m),work)
           elseif (iswp .eq. 1) then 
              call sor5ptf(ap,dinv(indx(m)),q,p,
     &                     ngx,ngy,xl,yl,
     &                     nr1,omega, 
     &                     ix0(m),iy0(m),work)
           elseif (iswp .eq. 2) then
              call pjacf(ap,dinv(indx(m)),q,p,
     &                   ngx,ngy,xl,yl,
     &                   nr1,omega, 
     &                   ix0(m),iy0(m),work)
           elseif (iswp .eq. 3) then
              call pjac2f(ap,dinv(indx(m)),q,p,
     &                    ngx,ngy,xl,yl,
     &                    nr1,omega, 
     &                    ix0(m),iy0(m),work)
           elseif (iswp .eq. 4) then
              call pjacf(ap,dinv(indx(m)),q,p,
     &                   ngx,ngy,xl,yl,
     &                   nr1,omega, 
     &                   ix0(m),iy0(m),work)
           endif
         endif
c
c     Compute residual on the finest grid.
c
         if (nr1 .eq. 0 .and. it .eq. 0) then
            do iy = 1,ngy
               do ix = 1,ngx
                  r(ix+(iy-1)*ngx) = p(ix,iy)
               enddo
            enddo
         else
            call remg2df(ap,q,p,ngx,ngy,xl,yl,r) 
         endif
C     
         ipt9c = (indx(m-1)-1)*9 + 1
         ipt4f = (indx(m)-1)*4 + 1
         nxyf = nx(m)*ny(m)
         nxyc = nx(m-1)*ny(m-1)
C     
C     Restriction mapping of the residual from G_k+1 to G_k.
C
         call restr2d(r,nx(m),ny(m),
     &                f(indx(m-1)),nx(m-1),ny(m-1), 
     &                wrst(ipt9c), 
     &                ix0(m),iy0(m),work)
c
C     Call MG cycle
C     All subroutines inside this IF-LOOP is put in the file MGCYC.C 
c
         mc = m-1
  
         if (icyc .eq. 0) then
            if (imin .eq. 0) then
               call vcycle(f,w,
     &                     acor,dinv, 
     &                     mc,nx,ny,xl,yl,indx,icyc, 
     &                     omega,iswp,nr1,nr2,md,mj,
     &                     wrst,witp,r,
     &                     ix0,iy0, 
     &                     neigx,neigy,work)
            endif
         elseif (icyc .eq. 1) then
            if (imin .eq. 0) then
               call fcycle(f,w,
     &                     acor,dinv, 
     &                     mc,nx,ny,xl,yl,indx,icyc, 
     &                     omega,iswp,nr1,nr2,md,mj,
     &                     wrst,witp,r,
     &                     ix0,iy0, 
     &                     neigx,neigy,work)
            endif 
         endif
c     
c     Correction
c     
         call extup2d(w(indx(m-1)),
     &                nx(m-1),ny(m-1), 
     &                q,nx(m),ny(m), 
     &                witp(ipt4f), 
     &                ix0(m),iy0(m),
     &                neigx(1,m),neigy(1,m),work)
C     
C     Post-smoothing 1
C
         if (iswp .eq. 0) then
            call sor2c4f(ap,dinv(indx(m)),q,p,
     &                   ngx,ngy,xl,yl,
     &                   nr2,omega, 
     &                   ix0(m),iy0(m),work)
         elseif (iswp .eq. 1) then
            call sor5ptf(ap,dinv(indx(m)),q,p,
     &                   ngx,ngy,xl,yl,
     &                   nr2,omega, 
     &                   ix0(m),iy0(m),work)
         elseif (iswp .eq. 2) then
            call pjacf(ap,dinv(indx(m)),q,p,
     &                 ngx,ngy,xl,yl,
     &                 nr2,omega, 
     &                 ix0(m),iy0(m),work)
         elseif (iswp .eq. 3) then
            call pjac2f(ap,dinv(indx(m)),q,p,
     &                  ngx,ngy,xl,yl,
     &                  nr2,omega, 
     &                  ix0(m),iy0(m),work)
         elseif (iswp .eq. 4) then
            call pjacf(ap,dinv(indx(m)),q,p,
     &                 ngx,ngy,xl,yl,
     &                 nr2,omega, 
     &                 ix0(m),iy0(m),work)
         endif
      enddo
c      write(*,*) m
c      write(*,*) '======'
c      
      return
      end
