      subroutine mkmg2d(ngx,ngy, 
     &                  m,ids,iswp, 
     &                  indx, 
     &                  nx,ny, 
     &                  wrst,witp,work,
     &                  ap,
     &                  acor,dinv, 
     &                  ix0,iy0,
     &                  ixg,iyg,
     &                  ippx,ippy, 
     &                  nppx,nppy,  
     &                  neigx,neigy,
     &                  ngall0,ngall1)


      implicit    none
      
      integer     ix,iy,j,jf,k,ixf,iyf,ist,jst,ipt9 
      integer     nx0,ny0,nx1,ny1,ixg0,iyg0 
      integer     ierr,icomm  
     
      integer     ngx,ngy  
      INTEGER     M,IDS,ISWP,irst 
      INTEGER     INDX(M),NX(M),NY(M) 
      INTEGER     IX0(M),IY0(M),IXG(M),IYG(M)  
      INTEGER     IPPX(M),IPPY(M),NPPX(M),NPPY(M) 
      INTEGER     NEIGX(2,M),NEIGY(2,M),NEIGXC(2,M),NEIGYC(2,M) 
      integer     ngall0,ngall1 
      
      complex*16  ap(ngx*ngy*9),acor(9*ngall0),dinv(ngall0-1) 
      complex*16  work((ngx+2)*(ngy+2),3) 
      complex*16  czero,cone,cidd 
      complex*16  wrst(9*ngall0),witp(4*ngall1) 
      
      parameter      (czero = (0.d0,0.d0),
     &                cone  = (1.d0,0.d0),
     &                cidd  = (0.d0,1.d0))

      do k = m,2,-1
C
C     Make WITP(*) [or weight for prolongation]
C
         nx1 = nx(k)
         ny1 = ny(k)
         nx0 = nx(k-1)
         ny0 = ny(k-1)
c         
         irst = 1
c         
         if (irst .eq. 0) then
            if (k .eq. m) then
               call mkwitp2d(witp((indx(k)-1)*4+1),ap(1),
     &                       nx1,ny1,nx0,ny0, 
     &                       ix0(k),iy0(k),
     &                       ids, 
     &                       neigx(1,k),neigy(1,k),
     &                       work(1,1),work(1,2),work(1,3))
            else
              call mkwitp2d(witp((indx(k)-1)*4+1),acor((indx(k)-1)*9+1),
     &                       nx1,ny1,nx0,ny0, 
     &                       ix0(k),iy0(k),
     &                       ids, 
     &                       neigx(1,k),neigy(1,k),
     &                       work(1,1),work(1,2),work(1,3))
            endif
C
C     Make WRST(*) [or weight for restriction]
C
            call mkwrst2d(wrst((indx(k-1)-1)*9+1), 
     &                    witp((indx(k)-1)*4+1), 
     &                    k,m,nx0,ny0,nx1,ny1,
     &                    ix0(k),iy0(k),work(1,1))
c
         elseif (irst .eq. 1) then
c
            if (k .eq. m) then
               call mkwitp2d(witp((indx(k)-1)*4+1),ap(1),
     &                       nx1,ny1,nx0,ny0, 
     &                       ix0(k),iy0(k),
     &                       0, ! ids = 0
     &                       neigx(1,k),neigy(1,k),
     &                       work(1,1),work(1,2),work(1,3))
            else
              call mkwitp2d(witp((indx(k)-1)*4+1),acor((indx(k)-1)*9+1),
     &                       nx1,ny1,nx0,ny0, 
     &                       ix0(k),iy0(k),
     &                       0, ! ids = 0
     &                       neigx(1,k),neigy(1,k),
     &                       work(1,1),work(1,2),work(1,3))
            endif
C
C     Make WRST(*) [or weight for restriction]
C
            call mkwrst2d(wrst((indx(k-1)-1)*9+1), 
     &                    witp((indx(k)-1)*4+1), 
     &                    k,m,nx0,ny0,nx1,ny1,
     &                    ix0(k),iy0(k),work(1,1))
c
            if (k .eq. m) then
               call mkwitp2d(witp((indx(k)-1)*4+1),ap(1),
     &                       nx1,ny1,nx0,ny0, 
     &                       ix0(k),iy0(k),
     &                       2, ! ids = 2
     &                       neigx(1,k),neigy(1,k),
     &                       work(1,1),work(1,2),work(1,3))
            else
              call mkwitp2d(witp((indx(k)-1)*4+1),acor((indx(k)-1)*9+1),
     &                       nx1,ny1,nx0,ny0, 
     &                       ix0(k),iy0(k),
     &                       2, ! ids = 2
     &                       neigx(1,k),neigy(1,k),
     &                       work(1,1),work(1,2),work(1,3))
            endif
c         
         endif
c
         do j = (indx(k-1)-1)*9+1,(indx(k-1)-1)*9+nx0*ny0*9
            acor(j) = czero
         enddo
c
         ixg0 = ixg(k-1)
         iyg0 = iyg(k-1)
c
c     Here, (ixg, iyg) is the global grid number.
c
         do jst = 1,3
            do ist = 1,3
               call prep2mg(work(1,1),nx0,ny0,ist,jst,ixg0,iyg0) 
               call ext2d(work(1,1),nx0,ny0, 
     &                    work(1,2),nx1,ny1,
     &                    witp((indx(k)-1)*4+1), 
     &                    ix0(k),iy0(k),
     &                    neigx(1,k),neigy(1,k),
     &                    work(1,3))
c
               if (k .eq. m) then
                  call mat2d9p(nx1,ny1,work(1,2),work(1,1),
     &                         ap,work(1,3))
               else
                  call mat2d9p(nx1,ny1,work(1,2),work(1,1),
     &                         acor((indx(k)-1)*9+1),work(1,3))
               endif
c
               call restr2d(work(1,1),nx1,ny1, 
     &                      work(1,2),nx0,ny0, 
     &                      wrst((indx(k-1)-1)*9+1),
     &                      ix0(k),iy0(k),work(1,3))

               call post2mg(work(1,2),acor((indx(k-1)-1)*9+1), 
     &                      k,m,nx0,ny0, 
     &                      ist,jst,
     &                      ixg0,iyg0,work(1,3))
            enddo
         enddo         
         call trsp2mg(acor((indx(k-1)-1)*9+1),nx0,ny0,work(1,1),
     &                work(1,3))
      enddo
c
c     make DINV
c
      if (iswp .lt. 4) then         
         do k = 1,m-1
            ipt9 = (indx(k)-1)*9 + 1
            do j = 1,nx(k)*ny(k)
               dinv(j+indx(k)-1) = 1.d0/acor(j+ipt9+4*nx(k)*ny(k)-1)
            enddo
         enddo
         do j = 1,nx(m)*ny(m)
            dinv(j+indx(m)-1) = 1.d0/ap(j+4*nx(m)*ny(m))
         enddo
      endif
c      
      return
      end
