      subroutine mkwrst2d(wrst,witp,k,m,nx0,ny0,nx1,ny1,ixs0,iys0,work)
c
c     This subroutine makes weights of the restriction mapping from
c     G(nx1,ny1) to G(nx0,ny0). Here it is defined as the transpose 
c     of the prolongation mapping.
c
c
      implicit       none
      
      integer        k,m,irst 
      integer        ix0,iy0,ix1,iy1 
      integer        ixs0,iys0 
      integer        nx0,ny0,nx1,ny1 
      
      complex*16     wrst(nx0,ny0,-1:1,-1:1) 
      complex*16     witp(nx1,ny1,4)       
      complex*16     work(0:nx1+1,0:ny1+1) 
      complex*16     czero,cone,cidd,d 
      
      parameter      (czero = (0.d0,0.d0),
     &                cone  = (1.d0,0.d0), cidd = (0.d0,1.d0))

c
      if (nx1.lt.1 .or. ny1.lt.1) return
      
      irst = 0
c      
      if (irst .eq. 0) then
c
c     initialize
c
      do iy0 = 1, ny0
         do ix0 = 1, nx0
            wrst(ix0,iy0,-1,-1) = czero
            wrst(ix0,iy0, 0,-1) = czero
            wrst(ix0,iy0, 1,-1) = czero
            wrst(ix0,iy0,-1, 0) = czero
            wrst(ix0,iy0, 0, 0) = czero
            wrst(ix0,iy0, 1, 0) = czero
            wrst(ix0,iy0,-1, 1) = czero
            wrst(ix0,iy0, 0, 1) = czero
            wrst(ix0,iy0, 1, 1) = czero
         enddo
      enddo

c     (-1,-1)-component
      do iy1 = 0, ny1+1
         do ix1 = 0, nx1+1
            work(ix1,iy1) = czero
         enddo
      enddo
      do iy1 = 1, ny1
         do ix1 = 1, nx1
            work(ix1,iy1) = witp(ix1,iy1,4)
         enddo
      enddo

      do iy0 = 1, ny0
         iy1 = iys0 + iy0*2 -2
         do ix0 = 1, nx0
            ix1 = ixs0 + ix0*2 -2
            wrst(ix0,iy0,-1,-1) = work(ix1-1,iy1-1)
         enddo
      enddo

c     ( 0,-1)-component
      do iy1 = 0, ny1+1
         do ix1 = 0, nx1+1
            work(ix1,iy1) = czero
         enddo
      enddo
      do iy1 = 1, ny1
         do ix1 = 1, nx1
            work(ix1,iy1) = witp(ix1,iy1,2)
         enddo
      enddo

      do iy0 = 1, ny0
         iy1 = iys0 + iy0*2 -2
         do ix0 = 1, nx0
            ix1 = ixs0 + ix0*2 -2
            wrst(ix0,iy0,0,-1) = work(ix1,iy1-1)
         enddo
      enddo

c     ( 1,-1)-component
      do iy1 = 0, ny1+1
         do ix1 = 0, nx1+1
            work(ix1,iy1) = czero
         enddo
      enddo
      do iy1 = 1, ny1
         do ix1 = 1, nx1
            work(ix1,iy1) = witp(ix1,iy1,3)
         enddo
      enddo

c
      do iy0 = 1, ny0
         iy1 = iys0 + iy0*2 -2
         do ix0 = 1, nx0
            ix1 = ixs0 + ix0*2 -2
            wrst(ix0,iy0, 1,-1) = work(ix1+1,iy1-1)
         enddo
      enddo

c     (-1, 0)-component
      do iy1 = 0, ny1+1
         do ix1 = 0, nx1+1
            work(ix1,iy1) = 2.d0*czero
         enddo
      enddo
      do iy1 = 1, ny1
         do ix1 = 1, nx1
            work(ix1,iy1) = witp(ix1,iy1,2)
         enddo
      enddo

      do iy0 = 1, ny0
         iy1 = iys0 + iy0*2 -2
         do ix0 = 1, nx0
            ix1 = ixs0 + ix0*2 -2
            wrst(ix0,iy0,-1, 0) = work(ix1-1,iy1)
         enddo
      enddo

c     ( 0, 0)-component
      do iy0 = 1, ny0
         do ix0 = 1, nx0
            wrst(ix0,iy0, 0, 0) = cone
         enddo
      enddo

c     ( 1, 0)-component
      do iy1 = 0, ny1+1
         do ix1 = 0, nx1+1
            work(ix1,iy1) = czero
         enddo
      enddo
      do iy1 = 1, ny1
         do ix1 = 1, nx1
            work(ix1,iy1) = witp(ix1,iy1,1)
         enddo
      enddo

      do iy0 = 1, ny0
         iy1 = iys0 + iy0*2 -2
         do ix0 = 1, nx0
            ix1 = ixs0 + ix0*2 -2
            wrst(ix0,iy0, 1, 0) = work(ix1+1,iy1)
         enddo
      enddo

c     (-1, 1)-component
      do iy1 = 0, ny1+1
         do ix1 = 0, nx1+1
            work(ix1,iy1) = czero
         enddo
      enddo
      do iy1 = 1, ny1
         do ix1 = 1, nx1
            work(ix1,iy1) = witp(ix1,iy1,2)
         enddo
      enddo

      do iy0 = 1, ny0
         iy1 = iys0 + iy0*2 -2
         do ix0 = 1, nx0
            ix1 = ixs0 + ix0*2 -2
            wrst(ix0,iy0,-1, 1) = work(ix1-1,iy1+1)
         enddo
      enddo

c     ( 0, 1)-component
      do iy1 = 0, ny1+1
         do ix1 = 0, nx1+1
            work(ix1,iy1) = czero
         enddo
      enddo
      do iy1 = 1, ny1
         do ix1 = 1, nx1
            work(ix1,iy1) = witp(ix1,iy1,1)
         enddo
      enddo

      do iy0 = 1, ny0
         iy1 = iys0 + iy0*2 -2
         do ix0 = 1, nx0
            ix1 = ixs0 + ix0*2 -2
            wrst(ix0,iy0, 0, 1) = work(ix1,iy1+1)
         enddo
      enddo

c     ( 1, 1)-component
      do iy1 = 0, ny1+1
         do ix1 = 0, nx1+1
            work(ix1,iy1) = czero
         enddo
      enddo
      do iy1 = 1, ny1
         do ix1 = 1, nx1
            work(ix1,iy1) = witp(ix1,iy1,1)
         enddo
      enddo

      do iy0 = 1, ny0
         iy1 = iys0 + iy0*2 -2
         do ix0 = 1, nx0
            ix1 = ixs0 + ix0*2 -2
            wrst(ix0,iy0, 1, 1) = work(ix1+1,iy1+1)
         enddo
      enddo
      
      elseif (irst .eq. 1) then
      
      do iy0 = 1, ny0
         do ix0 = 1, nx0
            wrst(ix0,iy0,-1,-1) = czero
            wrst(ix0,iy0, 0,-1) = czero
            wrst(ix0,iy0, 1,-1) = czero
            wrst(ix0,iy0,-1, 0) = czero
            wrst(ix0,iy0, 0, 0) = 0.5d0*cone
            wrst(ix0,iy0, 1, 0) = czero
            wrst(ix0,iy0,-1, 1) = czero
            wrst(ix0,iy0, 0, 1) = czero
            wrst(ix0,iy0, 1, 1) = czero
         enddo
      enddo
      
      elseif (irst .eq. 2) then
c
c        full weighting
c
         d = 1.d0/16.d0*cone
         do iy0 = 1, ny0
            do ix0 = 1, nx0
               wrst(ix0,iy0,-1,-1) = d
               wrst(ix0,iy0, 0,-1) = 2.d0*d
               wrst(ix0,iy0, 1,-1) = d
               wrst(ix0,iy0,-1, 0) = 2.d0*d
               wrst(ix0,iy0, 0, 0) = 4.d0*d
               wrst(ix0,iy0, 1, 0) = 2.d0*d
               wrst(ix0,iy0,-1, 1) = d
               wrst(ix0,iy0, 0, 1) = 2.d0*d
               wrst(ix0,iy0, 1, 1) = d
            enddo
         enddo
         
      elseif (irst .eq. 3) then
c
c        Half weighting
c
         d = 1.d0/8.d0*cone
         do iy0 = 1, ny0
            do ix0 = 1, nx0
               wrst(ix0,iy0,-1,-1) = 0.d0
               wrst(ix0,iy0, 0,-1) = d
               wrst(ix0,iy0, 1,-1) = 0.d0
               wrst(ix0,iy0,-1, 0) = d
               wrst(ix0,iy0, 0, 0) = 4.d0*d
               wrst(ix0,iy0, 1, 0) = d
               wrst(ix0,iy0,-1, 1) = 0.d0
               wrst(ix0,iy0, 0, 1) = d
               wrst(ix0,iy0, 1, 1) = 0.d0
            enddo
         enddo
c
      endif
      
      do iy0 = 1,ny0
        do ix0 = 1,ny0
            wrst(ix0,iy0,-1,-1) =  conjg(wrst(ix0,iy0,-1,-1))
            wrst(ix0,iy0, 0,-1) =  conjg(wrst(ix0,iy0, 0,-1))
            wrst(ix0,iy0, 1,-1) =  conjg(wrst(ix0,iy0, 1,-1))
            wrst(ix0,iy0,-1, 0) =  conjg(wrst(ix0,iy0,-1, 0))
            wrst(ix0,iy0, 0, 0) =  conjg(wrst(ix0,iy0, 0, 0))
            wrst(ix0,iy0, 1, 0) =  conjg(wrst(ix0,iy0, 1, 0))
            wrst(ix0,iy0,-1, 1) =  conjg(wrst(ix0,iy0,-1, 1))
            wrst(ix0,iy0, 0, 1) =  conjg(wrst(ix0,iy0, 0, 1))
            wrst(ix0,iy0, 1, 1) =  conjg(wrst(ix0,iy0, 1, 1))
         enddo
      enddo

      return
      end
