      subroutine pmgrid(n,ngx,ngy,ap,ia,xl,yl, 
     &                  imgrid,rmgrid,mmax,ngall0,ngall1,nipre,nrpre, 
     &                  wpre,rpre,ipre,ip,work)
      
      implicit   none
           
      integer    i,j,k,n,ibc(2,2)   

C     Multigrid parameters
      integer    npx,npy,nglx,ngly,m,nr1,nr2,nit  
      integer    icyc,md,imin,iac,mr,ids,iswp,mj 
      integer    nipre,nrpre,mmax,ngall0,ngall1,ngall(2),imgrid(15)  
      real*8     epsac,rmgrid(3)      

c     Parallel computing parameters
      integer    nia,nip 
      parameter  (nia = 2,nip = 5)
      integer    ia(nia),ip(nip) 
      integer    ierr,mpi_comm_world 
      integer    ipe,ipx,ipy,ixs,iys,ixe,iye 
      integer    ngx,ngy   
      
      integer    ipre(nipre) 
      complex*16 wpre(nrpre) 
      complex*16 ap(*),rpre(nrpre),work(*)   
c 
      real*8     xl,yl    

c     Resolve multigrid parameter
      
      npx  = imgrid(1)
      npy  = imgrid(2)
      m    = imgrid(3)
      nr1  = imgrid(4)
      nr2  = imgrid(5)
      nit  = imgrid(6)
      icyc = imgrid(7)
      md   = imgrid(8)
      imin = imgrid(9)
      iac  = imgrid(10)
      mr   = imgrid(11)
      ids  = imgrid(12)
      iswp = imgrid(13)
      mj   = imgrid(14)
      
      epsac = rmgrid(1)

c     resolve ia
      nglx = ia(1)
      ngly = ia(2)
            
      ierr = 0
      mpi_comm_world = 0 
      ipe = 0
      
      ipx = mod(ipe,npx)
      ipy = ipe/npx
      
      ixs = (nglx*ipx)/npx + 1
      ixe = (nglx*(ipx+1))/npx
      iys = (ngly*ipy)/npy + 1
      iye = (ngly*(ipy+1))/npy
      ngx = ixe - ixs + 1
      ngy = iye - iys + 1     
c         
c     Data for matrix vector product
c
      call das2dx(ia,nia,
     &            ip,nip,
     &            ngx,ngy,
     &            npx,npy,
     &            ipx,ipy)
c      
      call dmg2d(ap,ia,
     &           wpre,rpre,nrpre,ipre,nipre,work,
     &           ip,
     &           icyc,md,mj,
     &           imin,iac,mr,
     &           ids,iswp,m,nit,nr1,nr2,
     &           epsac,
     &           ngall)
c      
      return
      end
