      subroutine remg2df(ap,w,b,ngx,ngy,xl,yl,r)
C
C     This subroutine returns the residual r = b - A*w for 
C     the 2D 5-point stencil on the finest grid.
C
      implicit       none
c      
      integer        ngx,ngy  
      integer        ix,iy 
      complex*16     ap(ngx,ngy,-1:1,-1:1) 
      complex*16     b(ngx,ngy),w(ngx,ngy),r(ngx,ngy) 
      real*8         xl,yl   
c
      if (ngx .lt. 1 .or. ngy .lt. 1) return
c
      do iy = 1,ngy
         if (iy .eq. 1) then
            do ix = 1,ngx
               if (ix .eq. 1) then
                   r(ix,iy) = b(ix,iy) 
     &                      - ap(ix,iy, 0, 1)*w(ix  ,iy+1)
     &                      - ap(ix,iy, 1, 0)*w(ix+1,iy  )
     &                      - ap(ix,iy, 0, 0)*w(ix  ,iy  )
               elseif (ix .eq. ngx) then
                   r(ix,iy) = b(ix,iy) 
     &                      - ap(ix,iy, 0, 1)*w(ix  ,iy+1)
     &                      - ap(ix,iy,-1, 0)*w(ix-1,iy  )
     &                      - ap(ix,iy, 0, 0)*w(ix  ,iy  )
               else
                   r(ix,iy) = b(ix,iy) 
     &                      - ap(ix,iy, 0, 1)*w(ix  ,iy+1)
     &                      - ap(ix,iy,-1, 0)*w(ix-1,iy  )
     &                      - ap(ix,iy, 0, 0)*w(ix  ,iy  )
     &                      - ap(ix,iy, 1, 0)*w(ix+1,iy  )
               endif
            enddo
         elseif (iy .eq. ngy) then
            do ix = 1,ngx
               if (ix .eq. 1) then
                   r(ix,iy) = b(ix,iy) 
     &                      - ap(ix,iy, 0,-1)*w(ix  ,iy-1)
     &                      - ap(ix,iy, 1, 0)*w(ix+1,iy  )
     &                      - ap(ix,iy, 0, 0)*w(ix  ,iy  )
               elseif (ix .eq. ngx) then
                   r(ix,iy) = b(ix,iy) 
     &                      - ap(ix,iy, 0,-1)*w(ix  ,iy-1)
     &                      - ap(ix,iy,-1, 0)*w(ix-1,iy  )
     &                      - ap(ix,iy, 0, 0)*w(ix  ,iy  )
               else
                   r(ix,iy) = b(ix,iy) 
     &                      - ap(ix,iy, 0,-1)*w(ix  ,iy-1)
     &                      - ap(ix,iy,-1, 0)*w(ix-1,iy  )
     &                      - ap(ix,iy, 0, 0)*w(ix  ,iy  )
     &                      - ap(ix,iy, 1, 0)*w(ix+1,iy  )
               endif
            enddo
         else
            do ix = 1,ngx
               if (ix .eq. 1) then
                   r(ix,iy) = b(ix,iy) 
     &                      - ap(ix,iy, 0,-1)*w(ix  ,iy-1)
     &                      - ap(ix,iy, 1, 0)*w(ix+1,iy  )
     &                      - ap(ix,iy, 0, 0)*w(ix  ,iy  )
     &                      - ap(ix,iy, 0, 1)*w(ix  ,iy+1)
               elseif (ix .eq. ngx) then
                   r(ix,iy) = b(ix,iy) 
     &                      - ap(ix,iy, 0,-1)*w(ix  ,iy-1)
     &                      - ap(ix,iy,-1, 0)*w(ix-1,iy  )
     &                      - ap(ix,iy, 0, 0)*w(ix  ,iy  )
     &                      - ap(ix,iy, 0, 1)*w(ix  ,iy+1)
               else
                   r(ix,iy) = b(ix,iy) 
     &                      - ap(ix,iy, 0,-1)*w(ix  ,iy-1)
     &                      - ap(ix,iy,-1, 0)*w(ix-1,iy  )
     &                      - ap(ix,iy, 0, 0)*w(ix  ,iy  )
     &                      - ap(ix,iy, 1, 0)*w(ix+1,iy  )
     &                      - ap(ix,iy, 0, 1)*w(ix  ,iy+1)
               endif
            enddo
         endif
      enddo
c      
      return
      end
c
c     ******************************************************************
c

      subroutine remg2dc(a,w,b,ngx,ngy,xl,yl,r)
c
c     This subroutine returns the residual r = b - A*w for 
c     the 2D 9-point stencil on a coarse grid.
c
      implicit       none
      
      integer        ngx,ngy 
      integer        ix,iy 
      complex*16     a(ngx,ngy,-1:1,-1:1) 
      complex*16     b(ngx,ngy),w(ngx,ngy),r(ngx,ngy) 
      real*8         xl,yl 
c
      if (ngx .lt. 1  .or. ngy .lt. 1) return
c
c      write(*,*) 'Inside remg2dc'
c      do iy = 1, ngy
c         do ix = 1, ngx
c            r(ix,iy) = b(ix,iy) 
c     &               - a(ix,iy,-1,-1)*w(ix-1,iy-1)
c     &               - a(ix,iy, 0,-1)*w(ix,iy-1)
c     &               - a(ix,iy, 1,-1)*w(ix+1,iy-1)
c     &               - a(ix,iy,-1, 0)*w(ix-1,iy)
c     &               - a(ix,iy, 0, 0)*w(ix,iy)
c     &               - a(ix,iy, 1, 0)*w(ix+1,iy)
c     &               - a(ix,iy,-1, 1)*w(ix-1,iy+1)
c     &               - a(ix,iy, 0, 1)*w(ix,iy+1)
c     &               - a(ix,iy, 1, 1)*w(ix+1,iy+1)
c         enddo
c      enddo

      
      do iy = 1,ngy
         if (iy .eq. 1) then
            do ix = 1,ngx
               if (ix .eq. 1) then
                  r(ix,iy) = b(ix,iy) 
     &               - a(ix,iy, 0, 0)*w(ix,iy)
     &               - a(ix,iy, 1, 0)*w(ix+1,iy)
     &               - a(ix,iy, 0, 1)*w(ix,iy+1)
     &               - a(ix,iy, 1, 1)*w(ix+1,iy+1) 
               elseif (ix .eq. ngx) then
                  r(ix,iy) = b(ix,iy) 
     &               - a(ix,iy,-1, 0)*w(ix-1,iy)
     &               - a(ix,iy, 0, 0)*w(ix,iy)
     &               - a(ix,iy,-1, 1)*w(ix-1,iy+1)
     &               - a(ix,iy, 0, 1)*w(ix,iy+1)
               else
                  r(ix,iy) = b(ix,iy) 
     &               - a(ix,iy,-1, 0)*w(ix-1,iy)
     &               - a(ix,iy, 0, 0)*w(ix,iy)
     &               - a(ix,iy, 1, 0)*w(ix+1,iy)
     &               - a(ix,iy,-1, 1)*w(ix-1,iy+1)
     &               - a(ix,iy, 0, 1)*w(ix,iy+1)
     &               - a(ix,iy, 1, 1)*w(ix+1,iy+1)
               endif
            enddo
         elseif (iy .eq. ngy) then
            do ix = 1,ngx
               if (ix .eq. 1) then
                  r(ix,iy) = b(ix,iy) 
     &               - a(ix,iy, 0,-1)*w(ix,iy-1)
     &               - a(ix,iy, 1,-1)*w(ix+1,iy-1)
     &               - a(ix,iy, 0, 0)*w(ix,iy)
     &               - a(ix,iy, 1, 0)*w(ix+1,iy)
               elseif (ix .eq. ngx) then
                  r(ix,iy) = b(ix,iy) 
     &               - a(ix,iy,-1,-1)*w(ix-1,iy-1)
     &               - a(ix,iy, 0,-1)*w(ix,iy-1)
     &               - a(ix,iy,-1, 0)*w(ix-1,iy)
     &               - a(ix,iy, 0, 0)*w(ix,iy)
               else
                  r(ix,iy) = b(ix,iy) 
     &               - a(ix,iy,-1,-1)*w(ix-1,iy-1)
     &               - a(ix,iy, 0,-1)*w(ix,iy-1)
     &               - a(ix,iy, 1,-1)*w(ix+1,iy-1)
     &               - a(ix,iy,-1, 0)*w(ix-1,iy)
     &               - a(ix,iy, 0, 0)*w(ix,iy)
     &               - a(ix,iy, 1, 0)*w(ix+1,iy)
               endif
            enddo
         else
            do ix = 1,ngx
               if (ix .eq. 1) then
                  r(ix,iy) = b(ix,iy) 
     &               - a(ix,iy, 0,-1)*w(ix,iy-1)
     &               - a(ix,iy, 1,-1)*w(ix+1,iy-1)
     &               - a(ix,iy, 0, 0)*w(ix,iy)
     &               - a(ix,iy, 1, 0)*w(ix+1,iy)
     &               - a(ix,iy, 0, 1)*w(ix,iy+1)
     &               - a(ix,iy, 1, 1)*w(ix+1,iy+1)
               elseif (ix .eq. ngx) then
                  r(ix,iy) = b(ix,iy) 
     &               - a(ix,iy,-1,-1)*w(ix-1,iy-1)
     &               - a(ix,iy, 0,-1)*w(ix,iy-1)
     &               - a(ix,iy,-1, 0)*w(ix-1,iy)
     &               - a(ix,iy, 0, 0)*w(ix,iy)
     &               - a(ix,iy,-1, 1)*w(ix-1,iy+1)
     &               - a(ix,iy, 0, 1)*w(ix,iy+1)
               else
                  r(ix,iy) = b(ix,iy) 
     &               - a(ix,iy,-1,-1)*w(ix-1,iy-1)
     &               - a(ix,iy, 0,-1)*w(ix,iy-1)
     &               - a(ix,iy, 1,-1)*w(ix+1,iy-1)
     &               - a(ix,iy,-1, 0)*w(ix-1,iy)
     &               - a(ix,iy, 0, 0)*w(ix,iy)
     &               - a(ix,iy, 1, 0)*w(ix+1,iy)
     &               - a(ix,iy,-1, 1)*w(ix-1,iy+1)
     &               - a(ix,iy, 0, 1)*w(ix,iy+1)
     &               - a(ix,iy, 1, 1)*w(ix+1,iy+1) 
               endif
            enddo
         endif
      enddo
c   
c      write(*,*) 'Ready to return some values'
      
      return
      end
