      subroutine trsp2mg(a,nx,ny,work1,work2)
c
c     This subroutine returns the transpose of the matrix
c     for 2d 9 point stencil.
c
      IMPLICIT       NONE
      
      INTEGER        IX,IY,ICX,ICY,IEX 
      INTEGER        NX,NY 
      COMPLEX*16     A(NX,NY,-1:1,-1:1) 
      COMPLEX*16     WORK1(0:NX+1,0:NY+1),WORK2(0:NX+1,0:NY+1) 
c
      if (nx.lt.1 .or. ny.lt.1) return
c
      do icy = -1, 0
         if (icy.eq.-1) iex = 1
         if (icy.eq. 0) iex = -1
         do icx = -1, iex
            do iy = 0, ny+1
               do ix = 0 , nx+1
                  work1(ix,iy) = (0.d0,0.d0)
                  work2(ix,iy) = (0.d0,0.d0)
               enddo
            enddo
            do iy = 1, ny
               do ix = 1, nx
                  work1(ix,iy) = a(ix,iy, -icx, -icy)
                  work2(ix,iy) = a(ix,iy,  icx,  icy)
               enddo
            enddo
            do iy = 1, ny
               do ix = 1, nx
                  a(ix,iy,-icx,-icy) = work2(ix-icx,iy-icy)
                  a(ix,iy, icx, icy) = work1(ix+icx,iy+icy)
               enddo
            enddo
         enddo
      enddo
      
c      open(11,file='acor2.dat')
c      do iy = 1,ny
c         do ix = 1,nx
c            write(11,*) a(ix,iy,-1,-1)
c            write(11,*) a(ix,iy,-1, 0)
c            write(11,*) a(ix,iy,-1, 1)
c            write(11,*) a(ix,iy, 0, 1)
c            write(11,*) a(ix,iy, 0, 0)
c            write(11,*) a(ix,iy, 0, 1)
c            write(11,*) a(ix,iy, 1,-1)
c            write(11,*) a(ix,iy, 1, 0)
c            write(11,*) a(ix,iy, 1, 1)
c         enddo
c      enddo
      
      return
      end
