      SUBROUTINE VCYCLE(F,W,
     &                  ACOR,DINV, 
     &                  KMG,NX,NY,xl,yl,INDX,ICYC, 
     &                  OMEGA,ISWP,NR1,NR2,MD,mj,
     &                  WRST,WITP,R,
     &                  IX0,IY0, 
     &                  NEIGX,NEIGY,work)
      
      IMPLICIT    NONE 
      INTEGER     KMG,KMGC,NR1,NR2,NR,MD,ISWP,ICYC,mj,icrs   
      INTEGER     KF,IPTF,IPT9F,IPT4F,NXF,NYF,NXYF 
      INTEGER     KC,IPTC,IPT9C,IPT4C,NXC,NYC,NXYC 
      
      INTEGER     INDX(*),NX(*),NY(*) 
      INTEGER     J,IX0(*),IY0(*) 
      INTEGER     NEIGX(2,*),NEIGY(2,*) 
      
      COMPLEX*16  ACOR(*),DINV(*) 
      COMPLEX*16  F(*),W(*),R(*) 
      complex*16  wrst(*),witp(*),work(*)  
      real*8      xl,yl  
      complex*16  omega 
      
c      write(*,*) kmg,mj
      kf    = kmg - 1
      ipt9f = (indx(kmg)-1)*9 + 1
      ipt4f = (indx(kmg)-1)*4 + 1
      iptf  = (indx(kmg)-1)*1 + 1
      nxf   = nx(kmg)
      nyf   = ny(kmg)
      nxyf  = nxf*nyf
      
C     INITIALIZE SOLUTION VECTOR
      
      do j = iptf,iptf+nxyf-1
          w(j) = (0.d0,0.d0)
      enddo
      
C     CHECK WHETHER THE LEVEL VISITED IS THE LOWEST ONE

      NR = MAX(NR1,NR2)

      if (kf .eq. 0) then
          if (iswp .eq. 0) then
            call sor2c4c(ACOR(IPT9F),DINV(IPTF),W(IPTF),F(IPTF),
     &                   NXF,NYF,xl,yl,
     &                   NR,OMEGA,
     &                   IX0(KF),IY0(KF),work)
            return
          elseif (iswp .eq. 1) then
            call sor5ptc(ACOR(IPT9F),DINV(IPTF),W(IPTF),F(IPTF),
     &                   NXF,NYF,xl,yl,
     &                   NR,OMEGA,
     &                   IX0(KF),IY0(KF),work)
            return
          elseif (iswp .eq. 2) then
            call pjacc(ACOR(IPT9F),DINV(IPTF),W(IPTF),F(IPTF),
     &                   NXF,NYF,xl,yl,
     &                   NR,OMEGA,
     &                   IX0(KF),IY0(KF),work)
            return
          elseif (iswp .eq. 3) then
            call pjac2c(ACOR(IPT9F),DINV(IPTF),W(IPTF),F(IPTF),
     &                   NXF,NYF,xl,yl,
     &                   NR,OMEGA,
     &                   IX0(KF),IY0(KF),work) 
            return
          elseif (iswp .eq. 4) then
            call pjacc(ACOR(IPT9F),DINV(IPTF),W(IPTF),F(IPTF),
     &                   NXF,NYF,xl,yl,
     &                   NR,OMEGA,
     &                   IX0(KF),IY0(KF),work)
            return
          endif
      endif
      
      KC    = KF - 1
      IPT9C = (INDX(KF)-1)*9 + 1
      IPT4C = (INDX(KF)-1)*4 + 1
      IPTC  = (INDX(KF)-1)*1 + 1
      NXC   = NX(KF)
      NYC   = NY(KF)
      NXYC  = NXC*NYC

      if (nr1 .gt. 0) then
         if (iswp .eq. 0) then
            call sor2c4c(ACOR(IPT9F),DINV(IPTF),W(IPTF),F(IPTF),
     &                   NXF,NYF,xl,yl,
     &                   NR1,OMEGA,
     &                   IX0(KF),IY0(KF),work)
            call remg2dc(ACOR(IPT9F),W(IPTF),F(IPTF),
     &                   NXF,NYF,xl,yl,R)
         elseif (iswp .eq. 1) then 
            call sor5ptc(ACOR(IPT9F),DINV(IPTF),W(IPTF),F(IPTF),
     &                   NXF,NYF,xl,yl,
     &                   nr1,OMEGA,
     &                   IX0(KF),IY0(KF),work)
            call remg2dc(ACOR(IPT9F),W(IPTF),F(IPTF),
     &                   NXF,NYF,xl,yl,R)
         elseif (iswp .eq. 2) then
            call pjacc(ACOR(IPT9F),DINV(IPTF),W(IPTF),F(IPTF),
     &                   NXF,NYF,xl,yl,
     &                   nr1,OMEGA,
     &                   IX0(KF),IY0(KF),work)
            call remg2dc(ACOR(IPT9F),W(IPTF),F(IPTF),
     &                   NXF,NYF,xl,yl,R)
         elseif (iswp .eq. 3) then
            call pjac2c(ACOR(IPT9F),DINV(IPTF),W(IPTF),F(IPTF),
     &                   NXF,NYF,xl,yl,
     &                   nr1,OMEGA,
     &                   IX0(KF),IY0(KF),work)
            call remg2dc(ACOR(IPT9F),W(IPTF),F(IPTF),
     &                   NXF,NYF,xl,yl,R)
         elseif (iswp .eq. 4) then
            call pjacc(ACOR(IPT9F),DINV(IPTF),W(IPTF),F(IPTF),
     &                   NXF,NYF,xl,yl,
     &                   nr1,OMEGA,
     &                   IX0(KF),IY0(KF),work)
            call remg2dc(ACOR(IPT9F),W(IPTF),F(IPTF),
     &                   NXF,NYF,xl,yl,R)
         endif
      else
         do j = 0,nxyf-1 
            r(j) = f(iptf+j)
         enddo
      endif
      
C     TRANSFER THE RESIDUAL R TO THE COARSE GRID
     
      CALL RESTR2D(R,NXF,NYF,
     &             F(IPTC),NXC,NYC,
     &	           WRST(IPT9C),
     &             IX0(KF),IY0(KF),work)

C     VISIT THE NEXT COARSER LEVEL. 
C     BY THIS, CVCYLE IS CALLED RECURSIVELY.
C     AN INTERFACE SUBROUTINE IS CALLED AND PASSED TO ALLOW RECURSION.
      
      KMGC = KMG-1
      CALL RECURS(F,W,
     &            ACOR,DINV,
     &            KMGC,NX,NY,xl,yl,INDX,0,
     &            OMEGA,ISWP,NR1,NR2,MD,mj,
     &            WRST,WITP,R,
     &            IX0,IY0,
     &            NEIGX,NEIGY,work)
     
C     PROLONGATION FROM THE COARSE LEVEL W_(KMG-1) AND ADD IT TO FINER
C     LEVEL W_KMG
      CALL EXTUP2D(W(IPTC),NXC,NYC,
     &             W(IPTF),NXF,NYF,
     &             WITP(IPT4F),
     &             IX0(KF),IY0(KF),
     &             NEIGX(2,KF),NEIGY(2,KF),work)

C     POST SMOOTHER

      IF (ISWP .EQ. 0) THEN
         CALL SOR2C4c(ACOR(IPT9F),DINV(IPTF),W(IPTF),F(IPTF),
     &                NXF,NYF,xl,yl,
     &                NR2,OMEGA,
     &                IX0(KF),IY0(KF),work)
      elseif (iswp .eq. 1) then
         call sor5ptc(ACOR(IPT9F),DINV(IPTF),W(IPTF),F(IPTF),
     &                NXF,NYF,xl,yl,
     &                nr2,OMEGA,
     &                IX0(KF),IY0(KF),work)
      elseif (iswp .eq. 2) then
         call pjacc(ACOR(IPT9F),DINV(IPTF),W(IPTF),F(IPTF),
     &              NXF,NYF,xl,yl,
     &              nr2,OMEGA,
     &              IX0(KF),IY0(KF),work) 
      elseif (iswp .eq. 3) then
         call pjac2c(ACOR(IPT9F),DINV(IPTF),W(IPTF),F(IPTF),
     &                 NXF,NYF,xl,yl,
     &                 nr2,OMEGA,
     &                 IX0(KF),IY0(KF),work)
      elseif (iswp .eq. 4) then
         call pjacc(ACOR(IPT9F),DINV(IPTF),W(IPTF),F(IPTF),
     &              NXF,NYF,xl,yl,
     &              nr2,OMEGA,
     &              IX0(KF),IY0(KF),work)
      endif
c      write(*,*) kmg,mj
      
      return
      end
